
/*
 * Copyright (C) 2010-2020 Oracle Corporation
 *
 * This file is part of the VirtualBox SDK, as available from
 * http://www.virtualbox.org.  This library is free software; you can
 * redistribute it and/or modify it under the terms of the GNU Lesser General
 * Public License as published by the Free Software Foundation, in version 2.1
 * as it comes in the "COPYING.LIB" file of the VirtualBox SDK distribution.
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
 * License for more details.
 *
 * IDHCPGroupCondition.java
 *
 * DO NOT EDIT! This is a generated file.
 * Generated from: src/VBox/Main/idl/VirtualBox.xidl (VirtualBox's interface definitions in XML)
 * Generator: src/VBox/Main/glue/glue-java.xsl
 */

package org.virtualbox_6_1;

import org.virtualbox_6_1.jaxws.*;
import javax.xml.ws.*;
import java.util.List;

public class IDHCPGroupCondition extends IUnknown
{

    public IDHCPGroupCondition(String wrapped, ObjectRefManager objMgr, VboxPortType port)
    {
        super(wrapped, objMgr, port);
    }

/**
Whether this is an inclusive or exclusive group membership condition
@return Boolean
*/
    public Boolean getInclusive()
    {
        try
        {
            Boolean retVal = port.idhcpGroupConditionGetInclusive(obj);
            return retVal;
        }
        catch (InvalidObjectFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
        catch (RuntimeFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
    }

/**
Whether this is an inclusive or exclusive group membership condition
@param value Boolean

*/
    public void setInclusive(Boolean value)
    {
        try
        {
        port.idhcpGroupConditionSetInclusive(obj, value);
        }
        catch (InvalidObjectFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
        catch (RuntimeFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
    }

/**
Defines how the{@link org.virtualbox_6_1.IDHCPGroupCondition#getValue()}is interpreted.
@return org.virtualbox_6_1.DHCPGroupConditionType
*/
    public org.virtualbox_6_1.DHCPGroupConditionType getType()
    {
        try
        {
            org.virtualbox_6_1.jaxws.DHCPGroupConditionType retVal = port.idhcpGroupConditionGetType(obj);
            return org.virtualbox_6_1.DHCPGroupConditionType.fromValue(retVal.value());
        }
        catch (InvalidObjectFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
        catch (RuntimeFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
    }

/**
Defines how the{@link org.virtualbox_6_1.IDHCPGroupCondition#getValue()}is interpreted.
@param value org.virtualbox_6_1.DHCPGroupConditionType

*/
    public void setType(org.virtualbox_6_1.DHCPGroupConditionType value)
    {
        try
        {
        port.idhcpGroupConditionSetType(obj, org.virtualbox_6_1.jaxws.DHCPGroupConditionType.fromValue(value.name()));
        }
        catch (InvalidObjectFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
        catch (RuntimeFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
    }

/**
The condition value.
@return String
*/
    public String getValue()
    {
        try
        {
            String retVal = port.idhcpGroupConditionGetValue(obj);
            return retVal;
        }
        catch (InvalidObjectFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
        catch (RuntimeFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
    }

/**
The condition value.
@param value String

*/
    public void setValue(String value)
    {
        try
        {
        port.idhcpGroupConditionSetValue(obj, value);
        }
        catch (InvalidObjectFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
        catch (RuntimeFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
    }
    public static IDHCPGroupCondition queryInterface(IUnknown obj)
    {
        return obj == null ?  null : new IDHCPGroupCondition(obj.getWrapped(), obj.getObjMgr(), obj.getRemoteWSPort());
    }

/**
Remove this condition from the group.
*/
    public void remove()
    {
        try
        {
        port.idhcpGroupConditionRemove(obj);
        }
        catch (InvalidObjectFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
        catch (RuntimeFaultMsg e)
        {
            throw new VBoxException(e.getMessage(), e, this.getObjMgr(), this.port);
        }
    }
}
